// fullscreen.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <stdio.h>

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);


///////////////////////////////////////////////////////////////////////////////
//http://support.microsoft.com/default.aspx?scid=kb;EN-US;q197585
//http://support.microsoft.com/default.aspx?scid=kb;en-us;Q179363
//http://msdn.microsoft.com/library/default.asp?url=/library/en-us/shellcc/platform/Shell/shell_int/Taskbar.asp
//http://support.microsoft.com/default.aspx?scid=kb;EN-US;q202099

//Important stuff

bool fullscreenmode=false;
RECT winrect;
LONG oldstyle;

void UnhideTaskbar()
{
	HWND hWndTaskbar = FindWindowA("Shell_traywnd", "");
	SetWindowPos(hWndTaskbar, HWND_TOPMOST, 0, 0, 0, 0, SWP_SHOWWINDOW);
}

void ShowFullScreen(HWND hWnd, bool fullscreen)
{
	if (fullscreen)
	{
		int screenx = GetSystemMetrics(SM_CXSCREEN);	//Must call this each time cause user might change screen res
		int screeny = GetSystemMetrics(SM_CYSCREEN);
		SetWindowLong(hWnd, GWL_STYLE, WS_BORDER);	//Set no thickframe or caption for win2000/xp
		SetWindowPos(hWnd, HWND_TOP, 0, 0, screenx, screeny, SWP_FRAMECHANGED | SWP_SHOWWINDOW);

	}
	else
	{

		int width = winrect.right - winrect.left;
		int height = winrect.bottom - winrect.top;
		SetWindowLong(hWnd, GWL_STYLE, oldstyle);
		SetWindowPos(hWnd,HWND_TOP, winrect.left,winrect.top,width,height,SWP_FRAMECHANGED | SWP_SHOWWINDOW);
	}
}

////////////////////////////////////////////////////////////////////////////////


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_FULLSCREEN, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_FULLSCREEN);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}


//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_FULLSCREEN);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_FULLSCREEN;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }


   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);
/////////////////////////////////////////////////////////
//More good stuff here
	UINT fActive = LOWORD(wParam);
	POINT pos;
	pos.x = LOWORD(lParam);  // horizontal position of cursor 
	pos.y  = HIWORD(lParam);  // vertical position of cursor 
	ClientToScreen(hWnd, &pos);  
	switch (message) 
	{

	case WM_MOUSEMOVE:
			if (fullscreenmode)
			{
				int screeny = GetSystemMetrics(SM_CYSCREEN);

				if (screeny - pos.y < 1) 
				{
						//Normally, you'd count how long the mouse was there
						UnhideTaskbar();
				}
				else return DefWindowProc(hWnd, message, wParam, lParam);
			}
			else return DefWindowProc(hWnd, message, wParam, lParam);
		break;

		case WM_ACTIVATE:
			if (fullscreenmode)  
			{
				if (fActive==WA_INACTIVE) UnhideTaskbar();
					else ShowFullScreen(hWnd, true);
			}
			return DefWindowProc(hWnd, message, wParam, lParam);;
		break;
///////////////////////////////////////////////////////////
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
/////////////////////////////////////////////////////////
//More good stuff here
				case IDM_FULLSCREEN:
					if (fullscreenmode==false)
					{
						oldstyle = GetWindowLong(hWnd, GWL_STYLE);			//Store style
						GetWindowRect(hWnd, &winrect);				//Get old pos
						ShowFullScreen(hWnd, true);
						fullscreenmode=true;
					}
					else
					{
						UnhideTaskbar();
						fullscreenmode=false;
					}
///////////////////////////////////////////////////////////
				   break;
				case IDM_EXIT:
				   ShowFullScreen(hWnd, false);
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


